import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
const _excluded = ["image", "description", "imageStyle", "class"];
import { createVNode as _createVNode } from "vue";
import classNames from '../_util/classNames';
import LocaleReceiver from '../locale-provider/LocaleReceiver';
import DefaultEmptyImg from './empty';
import SimpleEmptyImg from './simple';
import { filterEmpty } from '../_util/props-util';
import PropTypes from '../_util/vue-types';
import { withInstall } from '../_util/type';
import useConfigInject from '../_util/hooks/useConfigInject';
const defaultEmptyImg = _createVNode(DefaultEmptyImg, null, null);
const simpleEmptyImg = _createVNode(SimpleEmptyImg, null, null);
const Empty = (props, _ref) => {
  var _slots$image, _slots$description;
  let {
    slots = {},
    attrs
  } = _ref;
  const {
    direction,
    prefixCls: prefixClsRef
  } = useConfigInject('empty', props);
  const prefixCls = prefixClsRef.value;
  const _props$attrs = _objectSpread(_objectSpread({}, props), attrs),
    {
      image = ((_slots$image = slots.image) === null || _slots$image === void 0 ? void 0 : _slots$image.call(slots)) || defaultEmptyImg,
      description = ((_slots$description = slots.description) === null || _slots$description === void 0 ? void 0 : _slots$description.call(slots)) || undefined,
      imageStyle,
      class: className = ''
    } = _props$attrs,
    restProps = _objectWithoutProperties(_props$attrs, _excluded);
  return _createVNode(LocaleReceiver, {
    "componentName": "Empty",
    "children": locale => {
      const des = typeof description !== 'undefined' ? description : locale.description;
      const alt = typeof des === 'string' ? des : 'empty';
      let imageNode = null;
      if (typeof image === 'string') {
        imageNode = _createVNode("img", {
          "alt": alt,
          "src": image
        }, null);
      } else {
        imageNode = image;
      }
      return _createVNode("div", _objectSpread({
        "class": classNames(prefixCls, className, {
          [`${prefixCls}-normal`]: image === simpleEmptyImg,
          [`${prefixCls}-rtl`]: direction.value === 'rtl'
        })
      }, restProps), [_createVNode("div", {
        "class": `${prefixCls}-image`,
        "style": imageStyle
      }, [imageNode]), des && _createVNode("p", {
        "class": `${prefixCls}-description`
      }, [des]), slots.default && _createVNode("div", {
        "class": `${prefixCls}-footer`
      }, [filterEmpty(slots.default())])]);
    }
  }, null);
};
Empty.displayName = 'AEmpty';
Empty.PRESENTED_IMAGE_DEFAULT = defaultEmptyImg;
Empty.PRESENTED_IMAGE_SIMPLE = simpleEmptyImg;
Empty.inheritAttrs = false;
Empty.props = {
  prefixCls: String,
  image: PropTypes.any,
  description: PropTypes.any,
  imageStyle: {
    type: Object,
    default: undefined
  }
};
export default withInstall(Empty);