import { createVNode as _createVNode } from "vue";
import { defineComponent } from 'vue';
import useConfigInject from '../_util/hooks/useConfigInject';
import PropTypes from '../_util/vue-types';
export const listItemMetaProps = () => ({
  avatar: PropTypes.any,
  description: PropTypes.any,
  prefixCls: String,
  title: PropTypes.any
});
export default defineComponent({
  compatConfig: {
    MODE: 3
  },
  name: 'AListItemMeta',
  props: listItemMetaProps(),
  displayName: 'AListItemMeta',
  // 兼容历史函数式组件
  __ANT_LIST_ITEM_META: true,
  slots: Object,
  setup(props, _ref) {
    let {
      slots
    } = _ref;
    const {
      prefixCls
    } = useConfigInject('list', props);
    return () => {
      var _slots$title, _slots$description, _slots$avatar;
      const classString = `${prefixCls.value}-item-meta`;
      const title = props.title ?? ((_slots$title = slots.title) === null || _slots$title === void 0 ? void 0 : _slots$title.call(slots));
      const description = props.description ?? ((_slots$description = slots.description) === null || _slots$description === void 0 ? void 0 : _slots$description.call(slots));
      const avatar = props.avatar ?? ((_slots$avatar = slots.avatar) === null || _slots$avatar === void 0 ? void 0 : _slots$avatar.call(slots));
      const content = _createVNode("div", {
        "class": `${prefixCls.value}-item-meta-content`
      }, [title && _createVNode("h4", {
        "class": `${prefixCls.value}-item-meta-title`
      }, [title]), description && _createVNode("div", {
        "class": `${prefixCls.value}-item-meta-description`
      }, [description])]);
      return _createVNode("div", {
        "class": classString
      }, [avatar && _createVNode("div", {
        "class": `${prefixCls.value}-item-meta-avatar`
      }, [avatar]), (title || description) && content]);
    };
  }
});