import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
const _excluded = ["default"];
import { camelize } from 'vue';
import { flattenChildren } from '../_util/props-util';
export function getColumnKey(column, defaultKey) {
  if ('key' in column && column.key !== undefined && column.key !== null) {
    return column.key;
  }
  if (column.dataIndex) {
    return Array.isArray(column.dataIndex) ? column.dataIndex.join('.') : column.dataIndex;
  }
  return defaultKey;
}
export function getColumnPos(index, pos) {
  return pos ? `${pos}-${index}` : `${index}`;
}
export function renderColumnTitle(title, props) {
  if (typeof title === 'function') {
    return title(props);
  }
  return title;
}
export function convertChildrenToColumns() {
  let elements = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  const flattenElements = flattenChildren(elements);
  const columns = [];
  flattenElements.forEach(element => {
    var _element$props, _element$props2, _element$type;
    if (!element) {
      return;
    }
    const key = element.key;
    const style = ((_element$props = element.props) === null || _element$props === void 0 ? void 0 : _element$props.style) || {};
    const cls = ((_element$props2 = element.props) === null || _element$props2 === void 0 ? void 0 : _element$props2.class) || '';
    const props = element.props || {};
    for (const [k, v] of Object.entries(props)) {
      props[camelize(k)] = v;
    }
    const _ref = element.children || {},
      {
        default: children
      } = _ref,
      restSlots = _objectWithoutProperties(_ref, _excluded);
    const column = _objectSpread(_objectSpread(_objectSpread({}, restSlots), props), {}, {
      style,
      class: cls
    });
    if (key) {
      column.key = key;
    }
    if ((_element$type = element.type) !== null && _element$type !== void 0 && _element$type.__ANT_TABLE_COLUMN_GROUP) {
      column.children = convertChildrenToColumns(typeof children === 'function' ? children() : children);
    } else {
      var _element$children;
      const customRender = (_element$children = element.children) === null || _element$children === void 0 ? void 0 : _element$children.default;
      column.customRender = column.customRender || customRender;
    }
    columns.push(column);
  });
  return columns;
}