import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
const _excluded = ["ellipsis", "rel"];
import { createVNode as _createVNode, resolveDirective as _resolveDirective } from "vue";
import warning from '../_util/warning';
import Base, { baseProps } from './Base';
import omit from '../_util/omit';
export const linkProps = () => omit(_objectSpread(_objectSpread({}, baseProps()), {}, {
  ellipsis: {
    type: Boolean,
    default: undefined
  }
}), ['component']);
const Link = (props, _ref) => {
  let {
    slots,
    attrs
  } = _ref;
  const _props$attrs = _objectSpread(_objectSpread({}, props), attrs),
    {
      ellipsis,
      rel
    } = _props$attrs,
    restProps = _objectWithoutProperties(_props$attrs, _excluded);
  warning(typeof ellipsis !== 'object', 'Typography.Link', '`ellipsis` only supports boolean value.');
  const mergedProps = _objectSpread(_objectSpread({}, restProps), {}, {
    rel: rel === undefined && restProps.target === '_blank' ? 'noopener noreferrer' : rel,
    ellipsis: !!ellipsis,
    component: 'a'
  });
  // https://github.com/ant-design/ant-design/issues/26622
  // @ts-ignore
  delete mergedProps.navigate;
  return _createVNode(Base, mergedProps, slots);
};
Link.displayName = 'ATypographyLink';
Link.inheritAttrs = false;
Link.props = linkProps();
export default Link;