"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.anchorLinkProps = void 0;
var _vue = require("vue");
var _vueTypes = _interopRequireDefault(require("../_util/vue-types"));
var _propsUtil = require("../_util/props-util");
var _classNames = _interopRequireDefault(require("../_util/classNames"));
var _useConfigInject = _interopRequireDefault(require("../_util/hooks/useConfigInject"));
var _context = require("./context");
const anchorLinkProps = () => ({
  prefixCls: String,
  href: String,
  title: _vueTypes.default.any,
  target: String
});
exports.anchorLinkProps = anchorLinkProps;
var _default = exports.default = (0, _vue.defineComponent)({
  compatConfig: {
    MODE: 3
  },
  name: 'AAnchorLink',
  props: (0, _propsUtil.initDefaultProps)(anchorLinkProps(), {
    href: '#'
  }),
  slots: Object,
  setup(props, _ref) {
    let {
      slots
    } = _ref;
    let mergedTitle = null;
    const {
      handleClick: contextHandleClick,
      scrollTo,
      unregisterLink,
      registerLink,
      activeLink
    } = (0, _context.useInjectAnchor)();
    const {
      prefixCls
    } = (0, _useConfigInject.default)('anchor', props);
    const handleClick = e => {
      const {
        href
      } = props;
      contextHandleClick(e, {
        title: mergedTitle,
        href
      });
      scrollTo(href);
    };
    (0, _vue.watch)(() => props.href, (val, oldVal) => {
      (0, _vue.nextTick)(() => {
        unregisterLink(oldVal);
        registerLink(val);
      });
    });
    (0, _vue.onMounted)(() => {
      registerLink(props.href);
    });
    (0, _vue.onBeforeUnmount)(() => {
      unregisterLink(props.href);
    });
    return () => {
      var _slots$default;
      const {
        href,
        target
      } = props;
      const pre = prefixCls.value;
      const title = (0, _propsUtil.getPropsSlot)(slots, props, 'title');
      mergedTitle = title;
      const active = activeLink.value === href;
      const wrapperClassName = (0, _classNames.default)(`${pre}-link`, {
        [`${pre}-link-active`]: active
      });
      const titleClassName = (0, _classNames.default)(`${pre}-link-title`, {
        [`${pre}-link-title-active`]: active
      });
      return (0, _vue.createVNode)("div", {
        "class": wrapperClassName
      }, [(0, _vue.createVNode)("a", {
        "class": titleClassName,
        "href": href,
        "title": typeof title === 'string' ? title : '',
        "target": target,
        "onClick": handleClick
      }, [title]), (_slots$default = slots.default) === null || _slots$default === void 0 ? void 0 : _slots$default.call(slots)]);
    };
  }
});