"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ribbonProps = exports.default = void 0;
var _vue = require("vue");
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _utils = require("./utils");
var _vueTypes = _interopRequireDefault(require("../_util/vue-types"));
var _useConfigInject = _interopRequireDefault(require("../_util/hooks/useConfigInject"));
const _excluded = ["class", "style"];
const ribbonProps = () => ({
  prefix: String,
  color: {
    type: String
  },
  text: _vueTypes.default.any,
  placement: {
    type: String,
    default: 'end'
  }
});
exports.ribbonProps = ribbonProps;
var _default = exports.default = (0, _vue.defineComponent)({
  compatConfig: {
    MODE: 3
  },
  name: 'ABadgeRibbon',
  inheritAttrs: false,
  props: ribbonProps(),
  slots: Object,
  setup(props, _ref) {
    let {
      attrs,
      slots
    } = _ref;
    const {
      prefixCls,
      direction
    } = (0, _useConfigInject.default)('ribbon', props);
    const colorInPreset = (0, _vue.computed)(() => (0, _utils.isPresetColor)(props.color));
    const ribbonCls = (0, _vue.computed)(() => [prefixCls.value, `${prefixCls.value}-placement-${props.placement}`, {
      [`${prefixCls.value}-rtl`]: direction.value === 'rtl',
      [`${prefixCls.value}-color-${props.color}`]: colorInPreset.value
    }]);
    return () => {
      var _slots$default, _slots$text;
      const {
          class: className,
          style
        } = attrs,
        restAttrs = (0, _objectWithoutProperties2.default)(attrs, _excluded);
      const colorStyle = {};
      const cornerColorStyle = {};
      if (props.color && !colorInPreset.value) {
        colorStyle.background = props.color;
        cornerColorStyle.color = props.color;
      }
      return (0, _vue.createVNode)("div", (0, _objectSpread2.default)({
        "class": `${prefixCls.value}-wrapper`
      }, restAttrs), [(_slots$default = slots.default) === null || _slots$default === void 0 ? void 0 : _slots$default.call(slots), (0, _vue.createVNode)("div", {
        "class": [ribbonCls.value, className],
        "style": (0, _objectSpread2.default)((0, _objectSpread2.default)({}, colorStyle), style)
      }, [(0, _vue.createVNode)("span", {
        "class": `${prefixCls.value}-text`
      }, [props.text || ((_slots$text = slots.text) === null || _slots$text === void 0 ? void 0 : _slots$text.call(slots))]), (0, _vue.createVNode)("div", {
        "class": `${prefixCls.value}-corner`,
        "style": cornerColorStyle
      }, null)])]);
    };
  }
});