"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.breadcrumbItemProps = void 0;
var _vue = require("vue");
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _vueTypes = _interopRequireDefault(require("../_util/vue-types"));
var _propsUtil = require("../_util/props-util");
var _dropdown = _interopRequireDefault(require("../dropdown/dropdown"));
var _DownOutlined = _interopRequireDefault(require("@ant-design/icons-vue/lib/icons/DownOutlined"));
var _useConfigInject = _interopRequireDefault(require("../_util/hooks/useConfigInject"));
const _excluded = ["class", "style"];
const breadcrumbItemProps = () => ({
  prefixCls: String,
  href: String,
  separator: _vueTypes.default.any,
  overlay: _vueTypes.default.any,
  onClick: Function
});
exports.breadcrumbItemProps = breadcrumbItemProps;
var _default = exports.default = (0, _vue.defineComponent)({
  compatConfig: {
    MODE: 3
  },
  name: 'ABreadcrumbItem',
  inheritAttrs: false,
  __ANT_BREADCRUMB_ITEM: true,
  props: breadcrumbItemProps(),
  // emits: ['click'],
  slots: Object,
  setup(props, _ref) {
    let {
      slots,
      attrs
    } = _ref;
    const {
      prefixCls
    } = (0, _useConfigInject.default)('breadcrumb', props);
    /**
     * if overlay is have
     * Wrap a DropDown
     */
    const renderBreadcrumbNode = (breadcrumbItem, prefixCls) => {
      const overlay = (0, _propsUtil.getPropsSlot)(slots, props, 'overlay');
      if (overlay) {
        return (0, _vue.createVNode)(_dropdown.default, {
          "overlay": overlay,
          "placement": "bottom"
        }, {
          default: () => [(0, _vue.createVNode)("span", {
            "class": `${prefixCls}-overlay-link`
          }, [breadcrumbItem, (0, _vue.createVNode)(_DownOutlined.default, null, null)])]
        });
      }
      return breadcrumbItem;
    };
    return () => {
      const separator = (0, _propsUtil.getPropsSlot)(slots, props, 'separator') ?? '/';
      const children = (0, _propsUtil.getPropsSlot)(slots, props);
      const {
          class: cls,
          style
        } = attrs,
        restAttrs = (0, _objectWithoutProperties2.default)(attrs, _excluded);
      let link;
      if (props.href !== undefined) {
        link = (0, _vue.createVNode)("a", (0, _objectSpread2.default)({
          "class": `${prefixCls.value}-link`,
          "onClick": props.onClick
        }, restAttrs), [children]);
      } else {
        link = (0, _vue.createVNode)("span", (0, _objectSpread2.default)({
          "class": `${prefixCls.value}-link`,
          "onClick": props.onClick
        }, restAttrs), [children]);
      }
      // wrap to dropDown
      link = renderBreadcrumbNode(link, prefixCls.value);
      if (children) {
        return (0, _vue.createVNode)("span", {
          "class": cls,
          "style": style
        }, [link, separator && (0, _vue.createVNode)("span", {
          "class": `${prefixCls.value}-separator`
        }, [separator])]);
      }
      return null;
    };
  }
});