import type { ExtractPropTypes, PropType } from 'vue';
export type SwipeDirection = 'left' | 'down' | 'right' | 'up' | string;
export type LazyLoadTypes = 'ondemand' | 'progressive';
export type CarouselEffect = 'scrollx' | 'fade';
export type DotPosition = 'top' | 'bottom' | 'left' | 'right';
export interface CarouselRef {
    goTo: (slide: number, dontAnimate?: boolean) => void;
    next: () => void;
    prev: () => void;
    autoplay: (palyType?: 'update' | 'leave' | 'blur') => void;
    innerSlider: any;
}
export declare const carouselProps: () => {
    effect: PropType<CarouselEffect>;
    dots: {
        type: BooleanConstructor;
        default: boolean;
    };
    vertical: {
        type: BooleanConstructor;
        default: any;
    };
    autoplay: {
        type: BooleanConstructor;
        default: any;
    };
    easing: StringConstructor;
    beforeChange: PropType<(currentSlide: number, nextSlide: number) => void>;
    afterChange: PropType<(currentSlide: number) => void>;
    prefixCls: StringConstructor;
    accessibility: {
        type: BooleanConstructor;
        default: any;
    };
    nextArrow: import("vue-types").VueTypeValidableDef<any>;
    prevArrow: import("vue-types").VueTypeValidableDef<any>;
    pauseOnHover: {
        type: BooleanConstructor;
        default: any;
    };
    adaptiveHeight: {
        type: BooleanConstructor;
        default: any;
    };
    arrows: {
        type: BooleanConstructor;
        default: boolean;
    };
    autoplaySpeed: NumberConstructor;
    centerMode: {
        type: BooleanConstructor;
        default: any;
    };
    centerPadding: StringConstructor;
    cssEase: StringConstructor;
    dotsClass: StringConstructor;
    draggable: {
        type: BooleanConstructor;
        default: boolean;
    };
    fade: {
        type: BooleanConstructor;
        default: any;
    };
    focusOnSelect: {
        type: BooleanConstructor;
        default: any;
    };
    infinite: {
        type: BooleanConstructor;
        default: any;
    };
    initialSlide: NumberConstructor;
    lazyLoad: PropType<LazyLoadTypes>;
    rtl: {
        type: BooleanConstructor;
        default: any;
    };
    slide: StringConstructor;
    slidesToShow: NumberConstructor;
    slidesToScroll: NumberConstructor;
    speed: NumberConstructor;
    swipe: {
        type: BooleanConstructor;
        default: any;
    };
    swipeToSlide: {
        type: BooleanConstructor;
        default: any;
    };
    swipeEvent: PropType<(swipeDirection: SwipeDirection) => void>;
    touchMove: {
        type: BooleanConstructor;
        default: any;
    };
    touchThreshold: NumberConstructor;
    variableWidth: {
        type: BooleanConstructor;
        default: any;
    };
    useCSS: {
        type: BooleanConstructor;
        default: any;
    };
    slickGoTo: NumberConstructor;
    responsive: ArrayConstructor;
    dotPosition: {
        type: PropType<DotPosition>;
        default: any;
    };
    verticalSwiping: {
        type: BooleanConstructor;
        default: boolean;
    };
};
export type CarouselProps = Partial<ExtractPropTypes<ReturnType<typeof carouselProps>>>;
declare const _default: {
    new (...args: any[]): import("vue").CreateComponentPublicInstance<Readonly<ExtractPropTypes<{
        effect: PropType<CarouselEffect>;
        dots: {
            type: BooleanConstructor;
            default: boolean;
        };
        vertical: {
            type: BooleanConstructor;
            default: any;
        };
        autoplay: {
            type: BooleanConstructor;
            default: any;
        };
        easing: StringConstructor;
        beforeChange: PropType<(currentSlide: number, nextSlide: number) => void>;
        afterChange: PropType<(currentSlide: number) => void>;
        prefixCls: StringConstructor;
        accessibility: {
            type: BooleanConstructor;
            default: any;
        };
        nextArrow: import("vue-types").VueTypeValidableDef<any>;
        prevArrow: import("vue-types").VueTypeValidableDef<any>;
        pauseOnHover: {
            type: BooleanConstructor;
            default: any;
        };
        adaptiveHeight: {
            type: BooleanConstructor;
            default: any;
        };
        arrows: {
            type: BooleanConstructor;
            default: boolean;
        };
        autoplaySpeed: NumberConstructor;
        centerMode: {
            type: BooleanConstructor;
            default: any;
        };
        centerPadding: StringConstructor;
        cssEase: StringConstructor;
        dotsClass: StringConstructor;
        draggable: {
            type: BooleanConstructor;
            default: boolean;
        };
        fade: {
            type: BooleanConstructor;
            default: any;
        };
        focusOnSelect: {
            type: BooleanConstructor;
            default: any;
        };
        infinite: {
            type: BooleanConstructor;
            default: any;
        };
        initialSlide: NumberConstructor;
        lazyLoad: PropType<LazyLoadTypes>;
        rtl: {
            type: BooleanConstructor;
            default: any;
        };
        slide: StringConstructor;
        slidesToShow: NumberConstructor;
        slidesToScroll: NumberConstructor;
        speed: NumberConstructor;
        swipe: {
            type: BooleanConstructor;
            default: any;
        };
        swipeToSlide: {
            type: BooleanConstructor;
            default: any;
        };
        swipeEvent: PropType<(swipeDirection: SwipeDirection) => void>;
        touchMove: {
            type: BooleanConstructor;
            default: any;
        };
        touchThreshold: NumberConstructor;
        variableWidth: {
            type: BooleanConstructor;
            default: any;
        };
        useCSS: {
            type: BooleanConstructor;
            default: any;
        };
        slickGoTo: NumberConstructor;
        responsive: ArrayConstructor;
        dotPosition: {
            type: PropType<DotPosition>;
            default: any;
        };
        verticalSwiping: {
            type: BooleanConstructor;
            default: boolean;
        };
    }>>, () => import("vue/jsx-runtime").JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & Readonly<ExtractPropTypes<{
        effect: PropType<CarouselEffect>;
        dots: {
            type: BooleanConstructor;
            default: boolean;
        };
        vertical: {
            type: BooleanConstructor;
            default: any;
        };
        autoplay: {
            type: BooleanConstructor;
            default: any;
        };
        easing: StringConstructor;
        beforeChange: PropType<(currentSlide: number, nextSlide: number) => void>;
        afterChange: PropType<(currentSlide: number) => void>;
        prefixCls: StringConstructor;
        accessibility: {
            type: BooleanConstructor;
            default: any;
        };
        nextArrow: import("vue-types").VueTypeValidableDef<any>;
        prevArrow: import("vue-types").VueTypeValidableDef<any>;
        pauseOnHover: {
            type: BooleanConstructor;
            default: any;
        };
        adaptiveHeight: {
            type: BooleanConstructor;
            default: any;
        };
        arrows: {
            type: BooleanConstructor;
            default: boolean;
        };
        autoplaySpeed: NumberConstructor;
        centerMode: {
            type: BooleanConstructor;
            default: any;
        };
        centerPadding: StringConstructor;
        cssEase: StringConstructor;
        dotsClass: StringConstructor;
        draggable: {
            type: BooleanConstructor;
            default: boolean;
        };
        fade: {
            type: BooleanConstructor;
            default: any;
        };
        focusOnSelect: {
            type: BooleanConstructor;
            default: any;
        };
        infinite: {
            type: BooleanConstructor;
            default: any;
        };
        initialSlide: NumberConstructor;
        lazyLoad: PropType<LazyLoadTypes>;
        rtl: {
            type: BooleanConstructor;
            default: any;
        };
        slide: StringConstructor;
        slidesToShow: NumberConstructor;
        slidesToScroll: NumberConstructor;
        speed: NumberConstructor;
        swipe: {
            type: BooleanConstructor;
            default: any;
        };
        swipeToSlide: {
            type: BooleanConstructor;
            default: any;
        };
        swipeEvent: PropType<(swipeDirection: SwipeDirection) => void>;
        touchMove: {
            type: BooleanConstructor;
            default: any;
        };
        touchThreshold: NumberConstructor;
        variableWidth: {
            type: BooleanConstructor;
            default: any;
        };
        useCSS: {
            type: BooleanConstructor;
            default: any;
        };
        slickGoTo: NumberConstructor;
        responsive: ArrayConstructor;
        dotPosition: {
            type: PropType<DotPosition>;
            default: any;
        };
        verticalSwiping: {
            type: BooleanConstructor;
            default: boolean;
        };
    }>>, {
        infinite: boolean;
        rtl: boolean;
        vertical: boolean;
        draggable: boolean;
        fade: boolean;
        centerMode: boolean;
        useCSS: boolean;
        dots: boolean;
        swipeToSlide: boolean;
        verticalSwiping: boolean;
        swipe: boolean;
        variableWidth: boolean;
        adaptiveHeight: boolean;
        accessibility: boolean;
        autoplay: boolean;
        focusOnSelect: boolean;
        pauseOnHover: boolean;
        arrows: boolean;
        touchMove: boolean;
        dotPosition: DotPosition;
    }, true, {}, {}, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<ExtractPropTypes<{
        effect: PropType<CarouselEffect>;
        dots: {
            type: BooleanConstructor;
            default: boolean;
        };
        vertical: {
            type: BooleanConstructor;
            default: any;
        };
        autoplay: {
            type: BooleanConstructor;
            default: any;
        };
        easing: StringConstructor;
        beforeChange: PropType<(currentSlide: number, nextSlide: number) => void>;
        afterChange: PropType<(currentSlide: number) => void>;
        prefixCls: StringConstructor;
        accessibility: {
            type: BooleanConstructor;
            default: any;
        };
        nextArrow: import("vue-types").VueTypeValidableDef<any>;
        prevArrow: import("vue-types").VueTypeValidableDef<any>;
        pauseOnHover: {
            type: BooleanConstructor;
            default: any;
        };
        adaptiveHeight: {
            type: BooleanConstructor;
            default: any;
        };
        arrows: {
            type: BooleanConstructor;
            default: boolean;
        };
        autoplaySpeed: NumberConstructor;
        centerMode: {
            type: BooleanConstructor;
            default: any;
        };
        centerPadding: StringConstructor;
        cssEase: StringConstructor;
        dotsClass: StringConstructor;
        draggable: {
            type: BooleanConstructor;
            default: boolean;
        };
        fade: {
            type: BooleanConstructor;
            default: any;
        };
        focusOnSelect: {
            type: BooleanConstructor;
            default: any;
        };
        infinite: {
            type: BooleanConstructor;
            default: any;
        };
        initialSlide: NumberConstructor;
        lazyLoad: PropType<LazyLoadTypes>;
        rtl: {
            type: BooleanConstructor;
            default: any;
        };
        slide: StringConstructor;
        slidesToShow: NumberConstructor;
        slidesToScroll: NumberConstructor;
        speed: NumberConstructor;
        swipe: {
            type: BooleanConstructor;
            default: any;
        };
        swipeToSlide: {
            type: BooleanConstructor;
            default: any;
        };
        swipeEvent: PropType<(swipeDirection: SwipeDirection) => void>;
        touchMove: {
            type: BooleanConstructor;
            default: any;
        };
        touchThreshold: NumberConstructor;
        variableWidth: {
            type: BooleanConstructor;
            default: any;
        };
        useCSS: {
            type: BooleanConstructor;
            default: any;
        };
        slickGoTo: NumberConstructor;
        responsive: ArrayConstructor;
        dotPosition: {
            type: PropType<DotPosition>;
            default: any;
        };
        verticalSwiping: {
            type: BooleanConstructor;
            default: boolean;
        };
    }>>, () => import("vue/jsx-runtime").JSX.Element, {}, {}, {}, {
        infinite: boolean;
        rtl: boolean;
        vertical: boolean;
        draggable: boolean;
        fade: boolean;
        centerMode: boolean;
        useCSS: boolean;
        dots: boolean;
        swipeToSlide: boolean;
        verticalSwiping: boolean;
        swipe: boolean;
        variableWidth: boolean;
        adaptiveHeight: boolean;
        accessibility: boolean;
        autoplay: boolean;
        focusOnSelect: boolean;
        pauseOnHover: boolean;
        arrows: boolean;
        touchMove: boolean;
        dotPosition: DotPosition;
    }>;
    __isFragment?: never;
    __isTeleport?: never;
    __isSuspense?: never;
} & import("vue").ComponentOptionsBase<Readonly<ExtractPropTypes<{
    effect: PropType<CarouselEffect>;
    dots: {
        type: BooleanConstructor;
        default: boolean;
    };
    vertical: {
        type: BooleanConstructor;
        default: any;
    };
    autoplay: {
        type: BooleanConstructor;
        default: any;
    };
    easing: StringConstructor;
    beforeChange: PropType<(currentSlide: number, nextSlide: number) => void>;
    afterChange: PropType<(currentSlide: number) => void>;
    prefixCls: StringConstructor;
    accessibility: {
        type: BooleanConstructor;
        default: any;
    };
    nextArrow: import("vue-types").VueTypeValidableDef<any>;
    prevArrow: import("vue-types").VueTypeValidableDef<any>;
    pauseOnHover: {
        type: BooleanConstructor;
        default: any;
    };
    adaptiveHeight: {
        type: BooleanConstructor;
        default: any;
    };
    arrows: {
        type: BooleanConstructor;
        default: boolean;
    };
    autoplaySpeed: NumberConstructor;
    centerMode: {
        type: BooleanConstructor;
        default: any;
    };
    centerPadding: StringConstructor;
    cssEase: StringConstructor;
    dotsClass: StringConstructor;
    draggable: {
        type: BooleanConstructor;
        default: boolean;
    };
    fade: {
        type: BooleanConstructor;
        default: any;
    };
    focusOnSelect: {
        type: BooleanConstructor;
        default: any;
    };
    infinite: {
        type: BooleanConstructor;
        default: any;
    };
    initialSlide: NumberConstructor;
    lazyLoad: PropType<LazyLoadTypes>;
    rtl: {
        type: BooleanConstructor;
        default: any;
    };
    slide: StringConstructor;
    slidesToShow: NumberConstructor;
    slidesToScroll: NumberConstructor;
    speed: NumberConstructor;
    swipe: {
        type: BooleanConstructor;
        default: any;
    };
    swipeToSlide: {
        type: BooleanConstructor;
        default: any;
    };
    swipeEvent: PropType<(swipeDirection: SwipeDirection) => void>;
    touchMove: {
        type: BooleanConstructor;
        default: any;
    };
    touchThreshold: NumberConstructor;
    variableWidth: {
        type: BooleanConstructor;
        default: any;
    };
    useCSS: {
        type: BooleanConstructor;
        default: any;
    };
    slickGoTo: NumberConstructor;
    responsive: ArrayConstructor;
    dotPosition: {
        type: PropType<DotPosition>;
        default: any;
    };
    verticalSwiping: {
        type: BooleanConstructor;
        default: boolean;
    };
}>>, () => import("vue/jsx-runtime").JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
    infinite: boolean;
    rtl: boolean;
    vertical: boolean;
    draggable: boolean;
    fade: boolean;
    centerMode: boolean;
    useCSS: boolean;
    dots: boolean;
    swipeToSlide: boolean;
    verticalSwiping: boolean;
    swipe: boolean;
    variableWidth: boolean;
    adaptiveHeight: boolean;
    accessibility: boolean;
    autoplay: boolean;
    focusOnSelect: boolean;
    pauseOnHover: boolean;
    arrows: boolean;
    touchMove: boolean;
    dotPosition: DotPosition;
}, {}, string, {}> & (import("vue").VNodeProps & (import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & import("vue").Plugin));
export default _default;
