"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _vue = require("vue");
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _context = require("./context");
var _transition = require("../_util/transition");
var _useConfigInject = _interopRequireDefault(require("../_util/hooks/useConfigInject"));
var _collapseMotion = _interopRequireDefault(require("../_util/collapseMotion"));
var _default = exports.default = (0, _vue.defineComponent)({
  compatConfig: {
    MODE: 3
  },
  name: 'ErrorList',
  props: ['errors', 'help', 'onDomErrorVisibleChange', 'helpStatus', 'warnings'],
  setup(props) {
    const {
      prefixCls: rootPrefixCls
    } = (0, _useConfigInject.default)('', props);
    const {
      prefixCls,
      status
    } = (0, _context.useInjectFormItemPrefix)();
    const baseClassName = (0, _vue.computed)(() => `${prefixCls.value}-item-explain`);
    const visible = (0, _vue.computed)(() => !!(props.errors && props.errors.length));
    const innerStatus = (0, _vue.ref)(status.value);
    // Memo status in same visible
    (0, _vue.watch)([visible, status], () => {
      if (visible.value) {
        innerStatus.value = status.value;
      }
    });
    return () => {
      var _props$errors, _props$errors2;
      const colMItem = (0, _collapseMotion.default)(`${rootPrefixCls.value}-show-help-item`);
      const transitionGroupProps = (0, _transition.getTransitionGroupProps)(`${rootPrefixCls.value}-show-help-item`, colMItem);
      transitionGroupProps.class = baseClassName.value;
      return (_props$errors = props.errors) !== null && _props$errors !== void 0 && _props$errors.length ? (0, _vue.createVNode)(_transition.TransitionGroup, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, transitionGroupProps), {}, {
        "tag": "div"
      }), {
        default: () => [(_props$errors2 = props.errors) === null || _props$errors2 === void 0 ? void 0 : _props$errors2.map((error, index) => (0, _vue.createVNode)("div", {
          "key": index,
          "role": "alert",
          "class": innerStatus.value ? `${baseClassName.value}-${innerStatus.value}` : ''
        }, [error]))]
      }) : null;
    };
  }
});