import type { Plugin, ExtractPropTypes, PropType, HTMLAttributes } from 'vue';
import type { SpinProps } from '../spin';
import type { PaginationConfig } from '../pagination';
import Item from './Item';
import type { CustomSlotsType, Key } from '../_util/type';
import ItemMeta from './ItemMeta';
export type { ListItemProps } from './Item';
export type { ListItemMetaProps } from './ItemMeta';
export type ColumnType = 'gutter' | 'column' | 'xs' | 'sm' | 'md' | 'lg' | 'xl' | 'xxl' | 'xxxl';
export type ColumnCount = number;
export interface ListGridType {
    gutter?: number;
    column?: ColumnCount;
    xs?: ColumnCount;
    sm?: ColumnCount;
    md?: ColumnCount;
    lg?: ColumnCount;
    xl?: ColumnCount;
    xxl?: ColumnCount;
    xxxl?: ColumnCount;
}
export type ListSize = 'small' | 'default' | 'large';
export type ListItemLayout = 'horizontal' | 'vertical';
export declare const listProps: () => {
    bordered: {
        type: BooleanConstructor;
        default: any;
    };
    dataSource: import("vue-types").VueTypeValidableDef<unknown[]> & {
        default: () => unknown[];
    };
    extra: import("vue-types").VueTypeValidableDef<any>;
    grid: {
        type: PropType<ListGridType>;
        default: ListGridType;
    };
    itemLayout: PropType<ListItemLayout>;
    loading: {
        type: PropType<boolean | (SpinProps & HTMLAttributes)>;
        default: boolean | (SpinProps & HTMLAttributes);
    };
    loadMore: import("vue-types").VueTypeValidableDef<any>;
    pagination: {
        type: PropType<false | PaginationConfig>;
        default: false | PaginationConfig;
    };
    prefixCls: StringConstructor;
    rowKey: PropType<Key | ((item: any) => Key)>;
    renderItem: PropType<(opt: {
        item: any;
        index: number;
    }) => any>;
    size: PropType<ListSize>;
    split: {
        type: BooleanConstructor;
        default: any;
    };
    header: import("vue-types").VueTypeValidableDef<any>;
    footer: import("vue-types").VueTypeValidableDef<any>;
    locale: {
        type: PropType<ListLocale>;
    };
};
export interface ListLocale {
    emptyText: any;
}
export type ListProps = Partial<ExtractPropTypes<ReturnType<typeof listProps>>>;
declare const List: import("vue").DefineComponent<{
    bordered: {
        type: BooleanConstructor;
        default: any;
    };
    dataSource: import("vue-types").VueTypeValidableDef<unknown[]> & {
        default: () => unknown[];
    };
    extra: import("vue-types").VueTypeValidableDef<any>;
    grid: {
        type: PropType<ListGridType>;
        default: ListGridType;
    };
    itemLayout: PropType<ListItemLayout>;
    loading: {
        type: PropType<boolean | (SpinProps & HTMLAttributes)>;
        default: boolean | (SpinProps & HTMLAttributes);
    };
    loadMore: import("vue-types").VueTypeValidableDef<any>;
    pagination: {
        type: PropType<false | PaginationConfig>;
        default: false | PaginationConfig;
    };
    prefixCls: StringConstructor;
    rowKey: PropType<Key | ((item: any) => Key)>;
    renderItem: PropType<(opt: {
        item: any;
        index: number;
    }) => any>;
    size: PropType<ListSize>;
    split: {
        type: BooleanConstructor;
        default: any;
    };
    header: import("vue-types").VueTypeValidableDef<any>;
    footer: import("vue-types").VueTypeValidableDef<any>;
    locale: {
        type: PropType<ListLocale>;
    };
}, () => import("vue/jsx-runtime").JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<ExtractPropTypes<{
    bordered: {
        type: BooleanConstructor;
        default: any;
    };
    dataSource: import("vue-types").VueTypeValidableDef<unknown[]> & {
        default: () => unknown[];
    };
    extra: import("vue-types").VueTypeValidableDef<any>;
    grid: {
        type: PropType<ListGridType>;
        default: ListGridType;
    };
    itemLayout: PropType<ListItemLayout>;
    loading: {
        type: PropType<boolean | (SpinProps & HTMLAttributes)>;
        default: boolean | (SpinProps & HTMLAttributes);
    };
    loadMore: import("vue-types").VueTypeValidableDef<any>;
    pagination: {
        type: PropType<false | PaginationConfig>;
        default: false | PaginationConfig;
    };
    prefixCls: StringConstructor;
    rowKey: PropType<Key | ((item: any) => Key)>;
    renderItem: PropType<(opt: {
        item: any;
        index: number;
    }) => any>;
    size: PropType<ListSize>;
    split: {
        type: BooleanConstructor;
        default: any;
    };
    header: import("vue-types").VueTypeValidableDef<any>;
    footer: import("vue-types").VueTypeValidableDef<any>;
    locale: {
        type: PropType<ListLocale>;
    };
}>>, {
    split: boolean;
    grid: ListGridType;
    loading: boolean | (Partial<ExtractPropTypes<{
        prefixCls: StringConstructor;
        spinning: {
            type: BooleanConstructor;
            default: any;
        };
        size: PropType<import("../spin/Spin").SpinSize>;
        wrapperClassName: StringConstructor;
        tip: import("vue-types").VueTypeValidableDef<any>;
        delay: NumberConstructor;
        indicator: import("vue-types").VueTypeValidableDef<any>;
    }>> & HTMLAttributes);
    bordered: boolean;
    pagination: false | Partial<ExtractPropTypes<{
        position: PropType<import("../pagination/Pagination").PaginationPosition>;
        total: NumberConstructor;
        defaultCurrent: NumberConstructor;
        disabled: {
            type: BooleanConstructor;
            default: any;
        };
        current: NumberConstructor;
        defaultPageSize: NumberConstructor;
        pageSize: NumberConstructor;
        hideOnSinglePage: {
            type: BooleanConstructor;
            default: any;
        };
        showSizeChanger: {
            type: BooleanConstructor;
            default: any;
        };
        pageSizeOptions: PropType<(string | number)[]>;
        buildOptionText: PropType<(opt: {
            value: any;
        }) => any>;
        showQuickJumper: {
            type: PropType<boolean | {
                goButton?: any;
            }>;
            default: boolean | {
                goButton?: any;
            };
        };
        showTotal: PropType<(total: number, range: [number, number]) => any>;
        size: PropType<"default" | "small">;
        simple: {
            type: BooleanConstructor;
            default: any;
        };
        locale: ObjectConstructor;
        prefixCls: StringConstructor;
        selectPrefixCls: StringConstructor;
        totalBoundaryShowSizeChanger: NumberConstructor;
        selectComponentClass: StringConstructor;
        itemRender: PropType<(opt: {
            page: number;
            type: "page" | "prev" | "next" | "jump-prev" | "jump-next";
            originalElement: any;
        }) => any>;
        role: StringConstructor;
        responsive: BooleanConstructor;
        showLessItems: {
            type: BooleanConstructor;
            default: any;
        };
        onChange: PropType<(page: number, pageSize: number) => void>;
        onShowSizeChange: PropType<(current: number, size: number) => void>;
        'onUpdate:current': PropType<(current: number) => void>;
        'onUpdate:pageSize': PropType<(size: number) => void>;
    }>>;
    dataSource: unknown[];
}, CustomSlotsType<{
    extra: any;
    loadMore: any;
    renderItem: {
        item: any;
        index: number;
    };
    header: any;
    footer: any;
    default: any;
}>>;
export { ItemMeta as ListItemMeta, Item as ListItem };
declare const _default: typeof List & Plugin & {
    readonly Item: typeof Item & {
        readonly Meta: typeof ItemMeta;
    };
};
export default _default;
