"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.paginationProps = exports.paginationConfig = exports.default = void 0;
var _vue = require("vue");
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _LeftOutlined = _interopRequireDefault(require("@ant-design/icons-vue/lib/icons/LeftOutlined"));
var _RightOutlined = _interopRequireDefault(require("@ant-design/icons-vue/lib/icons/RightOutlined"));
var _DoubleLeftOutlined = _interopRequireDefault(require("@ant-design/icons-vue/lib/icons/DoubleLeftOutlined"));
var _DoubleRightOutlined = _interopRequireDefault(require("@ant-design/icons-vue/lib/icons/DoubleRightOutlined"));
var _select = _interopRequireDefault(require("../select"));
var _MiniSelect = _interopRequireDefault(require("./MiniSelect"));
var _LocaleReceiver = require("../locale-provider/LocaleReceiver");
var _vcPagination = _interopRequireDefault(require("../vc-pagination"));
var _en_US = _interopRequireDefault(require("../vc-pagination/locale/en_US"));
var _classNames = _interopRequireDefault(require("../_util/classNames"));
var _useConfigInject = _interopRequireDefault(require("../_util/hooks/useConfigInject"));
var _useBreakpoint = _interopRequireDefault(require("../_util/hooks/useBreakpoint"));
const _excluded = ["size", "itemRender", "buildOptionText", "selectComponentClass", "responsive"];
const paginationProps = () => ({
  total: Number,
  defaultCurrent: Number,
  disabled: {
    type: Boolean,
    default: undefined
  },
  current: Number,
  defaultPageSize: Number,
  pageSize: Number,
  hideOnSinglePage: {
    type: Boolean,
    default: undefined
  },
  showSizeChanger: {
    type: Boolean,
    default: undefined
  },
  pageSizeOptions: Array,
  buildOptionText: Function,
  showQuickJumper: {
    type: [Boolean, Object],
    default: undefined
  },
  showTotal: Function,
  size: String,
  simple: {
    type: Boolean,
    default: undefined
  },
  locale: Object,
  prefixCls: String,
  selectPrefixCls: String,
  totalBoundaryShowSizeChanger: Number,
  selectComponentClass: String,
  itemRender: Function,
  role: String,
  responsive: Boolean,
  showLessItems: {
    type: Boolean,
    default: undefined
  },
  onChange: Function,
  onShowSizeChange: Function,
  'onUpdate:current': Function,
  'onUpdate:pageSize': Function
});
exports.paginationProps = paginationProps;
const paginationConfig = () => (0, _objectSpread2.default)((0, _objectSpread2.default)({}, paginationProps()), {}, {
  position: String
});
exports.paginationConfig = paginationConfig;
var _default = exports.default = (0, _vue.defineComponent)({
  compatConfig: {
    MODE: 3
  },
  name: 'APagination',
  inheritAttrs: false,
  props: paginationProps(),
  // emits: ['change', 'showSizeChange', 'update:current', 'update:pageSize'],
  setup(props, _ref) {
    let {
      slots,
      attrs
    } = _ref;
    const {
      prefixCls,
      configProvider,
      direction
    } = (0, _useConfigInject.default)('pagination', props);
    const selectPrefixCls = (0, _vue.computed)(() => configProvider.getPrefixCls('select', props.selectPrefixCls));
    const breakpoint = (0, _useBreakpoint.default)();
    const [locale] = (0, _LocaleReceiver.useLocaleReceiver)('Pagination', _en_US.default, (0, _vue.toRef)(props, 'locale'));
    const getIconsProps = pre => {
      const ellipsis = (0, _vue.createVNode)("span", {
        "class": `${pre}-item-ellipsis`
      }, [(0, _vue.createTextVNode)("\u2022\u2022\u2022")]);
      let prevIcon = (0, _vue.createVNode)("button", {
        "class": `${pre}-item-link`,
        "type": "button",
        "tabindex": -1
      }, [(0, _vue.createVNode)(_LeftOutlined.default, null, null)]);
      let nextIcon = (0, _vue.createVNode)("button", {
        "class": `${pre}-item-link`,
        "type": "button",
        "tabindex": -1
      }, [(0, _vue.createVNode)(_RightOutlined.default, null, null)]);
      let jumpPrevIcon = (0, _vue.createVNode)("a", {
        "rel": "nofollow",
        "class": `${pre}-item-link`
      }, [(0, _vue.createVNode)("div", {
        "class": `${pre}-item-container`
      }, [(0, _vue.createVNode)(_DoubleLeftOutlined.default, {
        "class": `${pre}-item-link-icon`
      }, null), ellipsis])]);
      let jumpNextIcon = (0, _vue.createVNode)("a", {
        "rel": "nofollow",
        "class": `${pre}-item-link`
      }, [(0, _vue.createVNode)("div", {
        "class": `${pre}-item-container`
      }, [(0, _vue.createVNode)(_DoubleRightOutlined.default, {
        "class": `${pre}-item-link-icon`
      }, null), ellipsis])]);
      // change arrows direction in right-to-left direction
      if (direction.value === 'rtl') {
        [prevIcon, nextIcon] = [nextIcon, prevIcon];
        [jumpPrevIcon, jumpNextIcon] = [jumpNextIcon, jumpPrevIcon];
      }
      return {
        prevIcon,
        nextIcon,
        jumpPrevIcon,
        jumpNextIcon
      };
    };
    return () => {
      var _breakpoint$value;
      const {
          size,
          itemRender = slots.itemRender,
          buildOptionText = slots.buildOptionText,
          selectComponentClass,
          responsive
        } = props,
        restProps = (0, _objectWithoutProperties2.default)(props, _excluded);
      const isSmall = size === 'small' || !!((_breakpoint$value = breakpoint.value) !== null && _breakpoint$value !== void 0 && _breakpoint$value.xs && !size && responsive);
      const paginationProps = (0, _objectSpread2.default)((0, _objectSpread2.default)((0, _objectSpread2.default)((0, _objectSpread2.default)({}, restProps), getIconsProps(prefixCls.value)), {}, {
        prefixCls: prefixCls.value,
        selectPrefixCls: selectPrefixCls.value,
        selectComponentClass: selectComponentClass || (isSmall ? _MiniSelect.default : _select.default),
        locale: locale.value,
        buildOptionText
      }, attrs), {}, {
        class: (0, _classNames.default)({
          mini: isSmall,
          [`${prefixCls.value}-rtl`]: direction.value === 'rtl'
        }, attrs.class),
        itemRender
      });
      return (0, _vue.createVNode)(_vcPagination.default, paginationProps, null);
    };
  }
});