"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.popconfirmProps = exports.default = void 0;
var _vue = require("vue");
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _tooltip = _interopRequireDefault(require("../tooltip"));
var _abstractTooltipProps = _interopRequireDefault(require("../tooltip/abstractTooltipProps"));
var _vueTypes = _interopRequireDefault(require("../_util/vue-types"));
var _propsUtil = require("../_util/props-util");
var _buttonTypes = require("../button/buttonTypes");
var _ExclamationCircleFilled = _interopRequireDefault(require("@ant-design/icons-vue/lib/icons/ExclamationCircleFilled"));
var _button = _interopRequireDefault(require("../button"));
var _LocaleReceiver = require("../locale-provider/LocaleReceiver");
var _default2 = _interopRequireDefault(require("../locale-provider/default"));
var _type = require("../_util/type");
var _useMergedState = _interopRequireDefault(require("../_util/hooks/useMergedState"));
var _devWarning = _interopRequireDefault(require("../vc-util/devWarning"));
var _KeyCode = _interopRequireDefault(require("../_util/KeyCode"));
var _useConfigInject = _interopRequireDefault(require("../_util/hooks/useConfigInject"));
var _classNames = _interopRequireDefault(require("../_util/classNames"));
var _transition = require("../_util/transition");
var _vnode = require("../_util/vnode");
var _omit = _interopRequireDefault(require("../_util/omit"));
var _Tooltip = require("../tooltip/Tooltip");
var _ActionButton = _interopRequireDefault(require("../_util/ActionButton"));
const _excluded = ["placement", "overlayClassName"];
const popconfirmProps = () => (0, _objectSpread2.default)((0, _objectSpread2.default)({}, (0, _abstractTooltipProps.default)()), {}, {
  prefixCls: String,
  content: _vueTypes.default.any,
  title: _vueTypes.default.any,
  okType: {
    type: String,
    default: 'primary'
  },
  disabled: {
    type: Boolean,
    default: false
  },
  okText: _vueTypes.default.any,
  cancelText: _vueTypes.default.any,
  icon: _vueTypes.default.any,
  okButtonProps: {
    type: Object,
    default: undefined
  },
  cancelButtonProps: {
    type: Object,
    default: undefined
  },
  showCancel: {
    type: Boolean,
    default: true
  },
  onConfirm: Function,
  onCancel: Function
});
exports.popconfirmProps = popconfirmProps;
const Popconfirm = (0, _vue.defineComponent)({
  compatConfig: {
    MODE: 3
  },
  name: 'APopconfirm',
  props: (0, _propsUtil.initDefaultProps)(popconfirmProps(), (0, _objectSpread2.default)((0, _objectSpread2.default)({}, (0, _Tooltip.tooltipDefaultProps)()), {}, {
    trigger: 'click',
    transitionName: 'zoom-big',
    placement: 'top',
    mouseEnterDelay: 0.1,
    mouseLeaveDelay: 0.1,
    arrowPointAtCenter: false,
    autoAdjustOverflow: true,
    okType: 'primary',
    disabled: false
  })),
  slots: Object,
  emits: ['update:visible', 'visibleChange'],
  setup(props, _ref) {
    let {
      slots,
      emit,
      expose
    } = _ref;
    (0, _vue.onMounted)(() => {
      (0, _devWarning.default)(props.defaultVisible === undefined, 'Popconfirm', `'defaultVisible' is deprecated, please use 'v-model:visible'`);
    });
    const tooltipRef = (0, _vue.ref)();
    expose({
      getPopupDomNode: () => {
        var _tooltipRef$value, _tooltipRef$value$get;
        return (_tooltipRef$value = tooltipRef.value) === null || _tooltipRef$value === void 0 ? void 0 : (_tooltipRef$value$get = _tooltipRef$value.getPopupDomNode) === null || _tooltipRef$value$get === void 0 ? void 0 : _tooltipRef$value$get.call(_tooltipRef$value);
      }
    });
    const [visible, setVisible] = (0, _useMergedState.default)(false, {
      value: (0, _vue.toRef)(props, 'visible'),
      defaultValue: props.defaultVisible
    });
    const settingVisible = (value, e) => {
      if (props.visible === undefined) {
        setVisible(value);
      }
      emit('update:visible', value);
      emit('visibleChange', value, e);
    };
    const close = e => {
      settingVisible(false, e);
    };
    const onConfirm = e => {
      var _props$onConfirm;
      return (_props$onConfirm = props.onConfirm) === null || _props$onConfirm === void 0 ? void 0 : _props$onConfirm.call(props, e);
    };
    const onCancel = e => {
      var _props$onCancel;
      settingVisible(false, e);
      (_props$onCancel = props.onCancel) === null || _props$onCancel === void 0 ? void 0 : _props$onCancel.call(props, e);
    };
    const onKeyDown = e => {
      if (e.keyCode === _KeyCode.default.ESC && visible) {
        settingVisible(false, e);
      }
    };
    const onVisibleChange = value => {
      const {
        disabled
      } = props;
      if (disabled) {
        return;
      }
      settingVisible(value);
    };
    const {
      prefixCls: prefixClsConfirm,
      getPrefixCls
    } = (0, _useConfigInject.default)('popconfirm', props);
    const rootPrefixCls = (0, _vue.computed)(() => getPrefixCls());
    const popoverPrefixCls = (0, _vue.computed)(() => getPrefixCls('popover'));
    const btnPrefixCls = (0, _vue.computed)(() => getPrefixCls('btn'));
    const [popconfirmLocale] = (0, _LocaleReceiver.useLocaleReceiver)('Popconfirm', _default2.default.Popconfirm);
    const renderOverlay = () => {
      var _slots$title, _slots$cancel, _slots$okText, _slots$icon;
      const {
        okButtonProps,
        cancelButtonProps,
        title = (_slots$title = slots.title) === null || _slots$title === void 0 ? void 0 : _slots$title.call(slots),
        cancelText = (_slots$cancel = slots.cancel) === null || _slots$cancel === void 0 ? void 0 : _slots$cancel.call(slots),
        okText = (_slots$okText = slots.okText) === null || _slots$okText === void 0 ? void 0 : _slots$okText.call(slots),
        okType,
        icon = (_slots$icon = slots.icon) === null || _slots$icon === void 0 ? void 0 : _slots$icon.call(slots),
        showCancel = true
      } = props;
      const {
        cancelButton,
        okButton
      } = slots;
      const cancelProps = (0, _objectSpread2.default)({
        onClick: onCancel,
        size: 'small'
      }, cancelButtonProps);
      const okProps = (0, _objectSpread2.default)((0, _objectSpread2.default)({
        onClick: onConfirm
      }, (0, _buttonTypes.convertLegacyProps)(okType)), {}, {
        size: 'small'
      }, okButtonProps);
      return (0, _vue.createVNode)("div", {
        "class": `${popoverPrefixCls.value}-inner-content`
      }, [(0, _vue.createVNode)("div", {
        "class": `${popoverPrefixCls.value}-message`
      }, [icon || (0, _vue.createVNode)(_ExclamationCircleFilled.default, null, null), (0, _vue.createVNode)("div", {
        "class": `${popoverPrefixCls.value}-message-title`
      }, [title])]), (0, _vue.createVNode)("div", {
        "class": `${popoverPrefixCls.value}-buttons`
      }, [showCancel ? cancelButton ? cancelButton(cancelProps) : (0, _vue.createVNode)(_button.default, cancelProps, {
        default: () => [cancelText || popconfirmLocale.value.cancelText]
      }) : null, okButton ? okButton(okProps) : (0, _vue.createVNode)(_ActionButton.default, {
        "buttonProps": (0, _objectSpread2.default)((0, _objectSpread2.default)({
          size: 'small'
        }, (0, _buttonTypes.convertLegacyProps)(okType)), okButtonProps),
        "actionFn": onConfirm,
        "close": close,
        "prefixCls": btnPrefixCls.value,
        "quitOnNullishReturnValue": true,
        "emitEvent": true
      }, {
        default: () => [okText || popconfirmLocale.value.okText]
      })])]);
    };
    return () => {
      var _slots$default;
      const {
          placement,
          overlayClassName
        } = props,
        restProps = (0, _objectWithoutProperties2.default)(props, _excluded);
      const otherProps = (0, _omit.default)(restProps, ['title', 'content', 'cancelText', 'okText', 'onUpdate:visible', 'onConfirm', 'onCancel']);
      const overlayClassNames = (0, _classNames.default)(prefixClsConfirm.value, overlayClassName);
      return (0, _vue.createVNode)(_tooltip.default, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, otherProps), {}, {
        "prefixCls": popoverPrefixCls.value,
        "placement": placement,
        "onVisibleChange": onVisibleChange,
        "visible": visible.value,
        "overlayClassName": overlayClassNames,
        "transitionName": (0, _transition.getTransitionName)(rootPrefixCls.value, 'zoom-big', props.transitionName),
        "ref": tooltipRef
      }), {
        default: () => [(0, _vnode.cloneVNodes)(((_slots$default = slots.default) === null || _slots$default === void 0 ? void 0 : _slots$default.call(slots)) || [], {
          onKeydown: e => {
            onKeyDown(e);
          }
        }, false)],
        title: renderOverlay
      });
    };
  }
});
var _default = exports.default = (0, _type.withInstall)(Popconfirm);