"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.statisticProps = exports.default = void 0;
var _vue = require("vue");
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _vueTypes = _interopRequireDefault(require("../_util/vue-types"));
var _initDefaultProps = _interopRequireDefault(require("../_util/props-util/initDefaultProps"));
var _Number = _interopRequireDefault(require("./Number"));
var _Skeleton = _interopRequireDefault(require("../skeleton/Skeleton"));
var _useConfigInject = _interopRequireDefault(require("../_util/hooks/useConfigInject"));
const statisticProps = () => ({
  prefixCls: String,
  decimalSeparator: String,
  groupSeparator: String,
  format: String,
  value: {
    type: [String, Number, Object]
  },
  valueStyle: {
    type: Object,
    default: undefined
  },
  valueRender: _vueTypes.default.any,
  formatter: _vueTypes.default.any,
  precision: Number,
  prefix: _vueTypes.default.any,
  suffix: _vueTypes.default.any,
  title: _vueTypes.default.any,
  loading: {
    type: Boolean,
    default: undefined
  }
});
exports.statisticProps = statisticProps;
var _default = exports.default = (0, _vue.defineComponent)({
  compatConfig: {
    MODE: 3
  },
  name: 'AStatistic',
  props: (0, _initDefaultProps.default)(statisticProps(), {
    decimalSeparator: '.',
    groupSeparator: ',',
    loading: false
  }),
  slots: Object,
  setup(props, _ref) {
    let {
      slots
    } = _ref;
    const {
      prefixCls,
      direction
    } = (0, _useConfigInject.default)('statistic', props);
    return () => {
      var _slots$title, _slots$prefix, _slots$suffix;
      const {
        value = 0,
        valueStyle,
        valueRender
      } = props;
      const pre = prefixCls.value;
      const title = props.title ?? ((_slots$title = slots.title) === null || _slots$title === void 0 ? void 0 : _slots$title.call(slots));
      const prefix = props.prefix ?? ((_slots$prefix = slots.prefix) === null || _slots$prefix === void 0 ? void 0 : _slots$prefix.call(slots));
      const suffix = props.suffix ?? ((_slots$suffix = slots.suffix) === null || _slots$suffix === void 0 ? void 0 : _slots$suffix.call(slots));
      const formatter = props.formatter ?? slots.formatter;
      // data-for-update just for update component
      // https://github.com/vueComponent/ant-design-vue/pull/3170
      let valueNode = (0, _vue.createVNode)(_Number.default, (0, _objectSpread2.default)({
        "data-for-update": Date.now()
      }, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, props), {}, {
        prefixCls: pre,
        value,
        formatter
      })), null);
      if (valueRender) {
        valueNode = valueRender(valueNode);
      }
      return (0, _vue.createVNode)("div", {
        "class": [pre, {
          [`${pre}-rtl`]: direction.value === 'rtl'
        }]
      }, [title && (0, _vue.createVNode)("div", {
        "class": `${pre}-title`
      }, [title]), (0, _vue.createVNode)(_Skeleton.default, {
        "paragraph": false,
        "loading": props.loading
      }, {
        default: () => [(0, _vue.createVNode)("div", {
          "style": valueStyle,
          "class": `${pre}-content`
        }, [prefix && (0, _vue.createVNode)("span", {
          "class": `${pre}-content-prefix`
        }, [prefix]), valueNode, suffix && (0, _vue.createVNode)("span", {
          "class": `${pre}-content-suffix`
        }, [suffix])])]
      })]);
    };
  }
});