import type { App, ExtractPropTypes, PropType } from 'vue';
import type { ProgressDotRender } from '../vc-steps/Steps';
import type { MouseEventHandler } from '../_util/EventInterface';
import type { CustomSlotsType } from '../_util/type';
export declare const stepsProps: () => {
    prefixCls: StringConstructor;
    iconPrefix: StringConstructor;
    current: NumberConstructor;
    initial: NumberConstructor;
    percent: NumberConstructor;
    responsive: {
        type: BooleanConstructor;
        default: any;
    };
    labelPlacement: PropType<"horizontal" | "vertical">;
    status: PropType<"wait" | "process" | "finish" | "error">;
    size: PropType<"default" | "small">;
    direction: PropType<"horizontal" | "vertical">;
    progressDot: {
        type: PropType<boolean | ProgressDotRender>;
        default: boolean | ProgressDotRender;
    };
    type: PropType<"default" | "navigation">;
    onChange: PropType<(current: number) => void>;
    'onUpdate:current': PropType<(current: number) => void>;
};
export declare const stepProps: () => {
    description: import("vue-types").VueTypeValidableDef<any>;
    icon: import("vue-types").VueTypeValidableDef<any>;
    status: PropType<"wait" | "process" | "finish" | "error">;
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    title: import("vue-types").VueTypeValidableDef<any>;
    subTitle: import("vue-types").VueTypeValidableDef<any>;
    onClick: PropType<MouseEventHandler>;
};
export type StepsProps = Partial<ExtractPropTypes<ReturnType<typeof stepsProps>>>;
export type StepProps = Partial<ExtractPropTypes<ReturnType<typeof stepProps>>>;
export declare const Step: import("vue").DefineComponent<{
    prefixCls: StringConstructor;
    wrapperStyle: {
        type: PropType<import("vue").CSSProperties>;
        default: import("vue").CSSProperties;
    };
    itemWidth: StringConstructor;
    active: {
        type: BooleanConstructor;
        default: any;
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    status: StringConstructor;
    iconPrefix: StringConstructor;
    icon: import("vue-types").VueTypeValidableDef<any>;
    adjustMarginRight: StringConstructor;
    stepNumber: NumberConstructor;
    stepIndex: NumberConstructor;
    description: import("vue-types").VueTypeValidableDef<any>;
    title: import("vue-types").VueTypeValidableDef<any>;
    subTitle: import("vue-types").VueTypeValidableDef<any>;
    progressDot: import("vue-types").VueTypeDef<any>;
    tailContent: import("vue-types").VueTypeValidableDef<any>;
    icons: import("vue-types").VueTypeLooseShape<{
        finish: any;
        error: any;
    }>;
    onClick: FunctionConstructor;
    onStepClick: FunctionConstructor;
    stepIcon: FunctionConstructor;
}, () => import("vue/jsx-runtime").JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("click" | "stepClick")[], "click" | "stepClick", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<ExtractPropTypes<{
    prefixCls: StringConstructor;
    wrapperStyle: {
        type: PropType<import("vue").CSSProperties>;
        default: import("vue").CSSProperties;
    };
    itemWidth: StringConstructor;
    active: {
        type: BooleanConstructor;
        default: any;
    };
    disabled: {
        type: BooleanConstructor;
        default: any;
    };
    status: StringConstructor;
    iconPrefix: StringConstructor;
    icon: import("vue-types").VueTypeValidableDef<any>;
    adjustMarginRight: StringConstructor;
    stepNumber: NumberConstructor;
    stepIndex: NumberConstructor;
    description: import("vue-types").VueTypeValidableDef<any>;
    title: import("vue-types").VueTypeValidableDef<any>;
    subTitle: import("vue-types").VueTypeValidableDef<any>;
    progressDot: import("vue-types").VueTypeDef<any>;
    tailContent: import("vue-types").VueTypeValidableDef<any>;
    icons: import("vue-types").VueTypeLooseShape<{
        finish: any;
        error: any;
    }>;
    onClick: FunctionConstructor;
    onStepClick: FunctionConstructor;
    stepIcon: FunctionConstructor;
}>> & {
    onClick?: (...args: any[]) => any;
    onStepClick?: (...args: any[]) => any;
}, {
    active: boolean;
    disabled: boolean;
    wrapperStyle: import("vue").CSSProperties;
}, {}>;
declare const _default: {
    new (...args: any[]): import("vue").CreateComponentPublicInstance<Readonly<ExtractPropTypes<{
        prefixCls: StringConstructor;
        iconPrefix: StringConstructor;
        current: NumberConstructor;
        initial: NumberConstructor;
        percent: NumberConstructor;
        responsive: {
            type: BooleanConstructor;
            default: any;
        };
        labelPlacement: PropType<"horizontal" | "vertical">;
        status: PropType<"wait" | "process" | "finish" | "error">;
        size: PropType<"default" | "small">;
        direction: PropType<"horizontal" | "vertical">;
        progressDot: {
            type: PropType<boolean | ProgressDotRender>;
            default: boolean | ProgressDotRender;
        };
        type: PropType<"default" | "navigation">;
        onChange: PropType<(current: number) => void>;
        'onUpdate:current': PropType<(current: number) => void>;
    }>>, () => import("vue/jsx-runtime").JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & Readonly<ExtractPropTypes<{
        prefixCls: StringConstructor;
        iconPrefix: StringConstructor;
        current: NumberConstructor;
        initial: NumberConstructor;
        percent: NumberConstructor;
        responsive: {
            type: BooleanConstructor;
            default: any;
        };
        labelPlacement: PropType<"horizontal" | "vertical">;
        status: PropType<"wait" | "process" | "finish" | "error">;
        size: PropType<"default" | "small">;
        direction: PropType<"horizontal" | "vertical">;
        progressDot: {
            type: PropType<boolean | ProgressDotRender>;
            default: boolean | ProgressDotRender;
        };
        type: PropType<"default" | "navigation">;
        onChange: PropType<(current: number) => void>;
        'onUpdate:current': PropType<(current: number) => void>;
    }>>, {
        responsive: boolean;
        progressDot: boolean | ProgressDotRender;
    }, true, {}, CustomSlotsType<{
        progressDot: any;
        default: any;
    }>, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<ExtractPropTypes<{
        prefixCls: StringConstructor;
        iconPrefix: StringConstructor;
        current: NumberConstructor;
        initial: NumberConstructor;
        percent: NumberConstructor;
        responsive: {
            type: BooleanConstructor;
            default: any;
        };
        labelPlacement: PropType<"horizontal" | "vertical">;
        status: PropType<"wait" | "process" | "finish" | "error">;
        size: PropType<"default" | "small">;
        direction: PropType<"horizontal" | "vertical">;
        progressDot: {
            type: PropType<boolean | ProgressDotRender>;
            default: boolean | ProgressDotRender;
        };
        type: PropType<"default" | "navigation">;
        onChange: PropType<(current: number) => void>;
        'onUpdate:current': PropType<(current: number) => void>;
    }>>, () => import("vue/jsx-runtime").JSX.Element, {}, {}, {}, {
        responsive: boolean;
        progressDot: boolean | ProgressDotRender;
    }>;
    __isFragment?: never;
    __isTeleport?: never;
    __isSuspense?: never;
} & import("vue").ComponentOptionsBase<Readonly<ExtractPropTypes<{
    prefixCls: StringConstructor;
    iconPrefix: StringConstructor;
    current: NumberConstructor;
    initial: NumberConstructor;
    percent: NumberConstructor;
    responsive: {
        type: BooleanConstructor;
        default: any;
    };
    labelPlacement: PropType<"horizontal" | "vertical">;
    status: PropType<"wait" | "process" | "finish" | "error">;
    size: PropType<"default" | "small">;
    direction: PropType<"horizontal" | "vertical">;
    progressDot: {
        type: PropType<boolean | ProgressDotRender>;
        default: boolean | ProgressDotRender;
    };
    type: PropType<"default" | "navigation">;
    onChange: PropType<(current: number) => void>;
    'onUpdate:current': PropType<(current: number) => void>;
}>>, () => import("vue/jsx-runtime").JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {
    responsive: boolean;
    progressDot: boolean | ProgressDotRender;
}, {}, string, CustomSlotsType<{
    progressDot: any;
    default: any;
}>> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & {
    Step: import("vue").DefineComponent<{
        prefixCls: StringConstructor;
        wrapperStyle: {
            type: PropType<import("vue").CSSProperties>;
            default: import("vue").CSSProperties;
        };
        itemWidth: StringConstructor;
        active: {
            type: BooleanConstructor;
            default: any;
        };
        disabled: {
            type: BooleanConstructor;
            default: any;
        };
        status: StringConstructor;
        iconPrefix: StringConstructor;
        icon: import("vue-types").VueTypeValidableDef<any>;
        adjustMarginRight: StringConstructor;
        stepNumber: NumberConstructor;
        stepIndex: NumberConstructor;
        description: import("vue-types").VueTypeValidableDef<any>;
        title: import("vue-types").VueTypeValidableDef<any>;
        subTitle: import("vue-types").VueTypeValidableDef<any>;
        progressDot: import("vue-types").VueTypeDef<any>;
        tailContent: import("vue-types").VueTypeValidableDef<any>;
        icons: import("vue-types").VueTypeLooseShape<{
            finish: any;
            error: any;
        }>;
        onClick: FunctionConstructor;
        onStepClick: FunctionConstructor;
        stepIcon: FunctionConstructor;
    }, () => import("vue/jsx-runtime").JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("click" | "stepClick")[], "click" | "stepClick", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<ExtractPropTypes<{
        prefixCls: StringConstructor;
        wrapperStyle: {
            type: PropType<import("vue").CSSProperties>;
            default: import("vue").CSSProperties;
        };
        itemWidth: StringConstructor;
        active: {
            type: BooleanConstructor;
            default: any;
        };
        disabled: {
            type: BooleanConstructor;
            default: any;
        };
        status: StringConstructor;
        iconPrefix: StringConstructor;
        icon: import("vue-types").VueTypeValidableDef<any>;
        adjustMarginRight: StringConstructor;
        stepNumber: NumberConstructor;
        stepIndex: NumberConstructor;
        description: import("vue-types").VueTypeValidableDef<any>;
        title: import("vue-types").VueTypeValidableDef<any>;
        subTitle: import("vue-types").VueTypeValidableDef<any>;
        progressDot: import("vue-types").VueTypeDef<any>;
        tailContent: import("vue-types").VueTypeValidableDef<any>;
        icons: import("vue-types").VueTypeLooseShape<{
            finish: any;
            error: any;
        }>;
        onClick: FunctionConstructor;
        onStepClick: FunctionConstructor;
        stepIcon: FunctionConstructor;
    }>> & {
        onClick?: (...args: any[]) => any;
        onStepClick?: (...args: any[]) => any;
    }, {
        active: boolean;
        disabled: boolean;
        wrapperStyle: import("vue").CSSProperties;
    }, {}>;
    install: (app: App) => App<any>;
};
export default _default;
