"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.typographyProps = exports.default = void 0;
var _vue = require("vue");
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _useConfigInject = _interopRequireDefault(require("../_util/hooks/useConfigInject"));
var _classNames = _interopRequireDefault(require("../_util/classNames"));
const _excluded = ["prefixCls", "direction", "component"];
const typographyProps = () => ({
  prefixCls: String,
  direction: String,
  // Form Internal use
  component: String
});
exports.typographyProps = typographyProps;
const Typography = (0, _vue.defineComponent)({
  name: 'ATypography',
  inheritAttrs: false,
  props: typographyProps(),
  setup(props, _ref) {
    let {
      slots,
      attrs
    } = _ref;
    const {
      prefixCls,
      direction
    } = (0, _useConfigInject.default)('typography', props);
    return () => {
      var _slots$default;
      const _props$attrs = (0, _objectSpread2.default)((0, _objectSpread2.default)({}, props), attrs),
        {
          prefixCls: _prefixCls,
          direction: _direction,
          component: Component = 'article'
        } = _props$attrs,
        restProps = (0, _objectWithoutProperties2.default)(_props$attrs, _excluded);
      return (0, _vue.createVNode)(Component, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, restProps), {}, {
        "class": (0, _classNames.default)(prefixCls.value, {
          [`${prefixCls.value}-rtl`]: direction.value === 'rtl'
        }, attrs.class)
      }), {
        default: () => [(_slots$default = slots.default) === null || _slots$default === void 0 ? void 0 : _slots$default.call(slots)]
      });
    };
  }
});
var _default = exports.default = Typography;