"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getRanges;
var _vue = require("vue");
function getRanges(_ref) {
  let {
    prefixCls,
    rangeList = [],
    components = {},
    needConfirmButton,
    onNow,
    onOk,
    okDisabled,
    showNow,
    locale
  } = _ref;
  let presetNode;
  let okNode;
  if (rangeList.length) {
    const Item = components.rangeItem || 'span';
    presetNode = (0, _vue.createVNode)(_vue.Fragment, null, [rangeList.map(_ref2 => {
      let {
        label,
        onClick,
        onMouseenter,
        onMouseleave
      } = _ref2;
      return (0, _vue.createVNode)("li", {
        "key": label,
        "class": `${prefixCls}-preset`
      }, [(0, _vue.createVNode)(Item, {
        "onClick": onClick,
        "onMouseenter": onMouseenter,
        "onMouseleave": onMouseleave
      }, {
        default: () => [label]
      })]);
    })]);
  }
  if (needConfirmButton) {
    const Button = components.button || 'button';
    if (onNow && !presetNode && showNow !== false) {
      presetNode = (0, _vue.createVNode)("li", {
        "class": `${prefixCls}-now`
      }, [(0, _vue.createVNode)("a", {
        "class": `${prefixCls}-now-btn`,
        "onClick": onNow
      }, [locale.now])]);
    }
    okNode = needConfirmButton && (0, _vue.createVNode)("li", {
      "class": `${prefixCls}-ok`
    }, [(0, _vue.createVNode)(Button, {
      "disabled": okDisabled,
      "onClick": onOk
    }, {
      default: () => [locale.ok]
    })]);
  }
  if (!presetNode && !okNode) {
    return null;
  }
  return (0, _vue.createVNode)("ul", {
    "class": `${prefixCls}-ranges`
  }, [presetNode, okNode]);
}